package com.zcloud.controller.accident;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.accident.AccidentService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：事故信息
 * 作者：luoxiaobao
 * 时间：2022-05-17
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/accident")
public class AccidentController extends BaseController {

	@Autowired
	private AccidentService accidentService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("accident:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("ACCIDENT_ID", this.get32UUID());	//主键
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//添加时间
		pd.put("ISDELETE", "0");	//是否删除 1-是  0-否
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		accidentService.save(pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("accident:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		accidentService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("accident:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		accidentService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("accident:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = accidentService.list(page);	//列出Accident列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("accident:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = accidentService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("accident:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			accidentService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "事故管理",instructionsOperate = "事故信息",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("企业ID");	//1
		titles.add("事故编号");	//2
		titles.add("事故名称");	//3
		titles.add("事故单位");	//4
		titles.add("事故涉及单位");	//5
		titles.add("事故级别");	//6
		titles.add("事故发生地点");	//7
		titles.add("事故发生时间");	//8
		titles.add("直接经济损失");	//9
		titles.add("受伤人数");	//10
		titles.add("死亡人数");	//11
		titles.add("重伤人数");	//12
		titles.add("起因物");	//13
		titles.add("是否被处罚");	//14
		titles.add("处罚金额");	//15
		titles.add("直接原因");	//16
		titles.add("间接原因");	//17
		titles.add("事故概述");	//18
		titles.add("填表人");	//19
		titles.add("添加时间");	//20
		titles.add("是否删除");	//21
		dataMap.put("titles", titles);
		List<PageData> varOList = accidentService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("CORPINFO_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("ACCIDENT_NUM"));	    //2
			vpd.put("var3", varOList.get(i).getString("ACCIDENT_NAME"));	    //3
			vpd.put("var4", varOList.get(i).getString("ACCIDENT_DEPT"));	    //4
			vpd.put("var5", varOList.get(i).getString("INVOLVING_DEPTS"));	    //5
			vpd.put("var6", varOList.get(i).getString("ACCIDENT_LEVEL"));	    //6
			vpd.put("var7", varOList.get(i).getString("ACCIDENT_PLACE"));	    //7
			vpd.put("var8", varOList.get(i).getString("ACCIDENT_TIME"));	    //8
			vpd.put("var9", varOList.get(i).get("ECONOMIC_LOSSES").toString());	//9
			vpd.put("var10", varOList.get(i).get("INJURED_NUM").toString());	//10
			vpd.put("var11", varOList.get(i).get("DEAD_NUM").toString());	//11
			vpd.put("var12", varOList.get(i).get("SERIOUSLY_INJURED_NUM").toString());	//12
			vpd.put("var13", varOList.get(i).getString("ACCIDENT_BECAUSE"));	    //13
			vpd.put("var14", varOList.get(i).get("IS_PUNISHMENT").toString());	//14
			vpd.put("var15", varOList.get(i).get("PUNISHMENT_AMOUNT").toString());	//15
			vpd.put("var16", varOList.get(i).getString("IMMEDIATE_CAUSE"));	    //16
			vpd.put("var17", varOList.get(i).getString("REMOTE_CAUSE"));	    //17
			vpd.put("var18", varOList.get(i).getString("ACCIDENT_DESCR"));	    //18
			vpd.put("var19", varOList.get(i).getString("CREATOR"));	    //19
			vpd.put("var20", varOList.get(i).getString("CREATTIME"));	    //20
			vpd.put("var21", varOList.get(i).getString("ISDELETE"));	    //21
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
